#include <usbdrv.h>
#include <avr/io.h>
#include <Wire.h> //I2C Arduino Library

#define addr 0x1E //I2C Address for The HMC5883
#define RQ_GET_DATA 4  
#define RQ_GET_SWITCH 2
#define IS_SW_PRESSED() ((PINB & (1<<PIN_PB3))==0)



struct Data {
int16_t x;
int16_t y;
int16_t z;
};
static int buttonState = 0;
Data data2;

//java.nio.ByteArray

usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  static uint8_t switch_state;
  usbRequest_t *rq = (usbRequest_t*)data;
  if (rq->bRequest == RQ_GET_DATA)
  {
    usbMsgPtr = (char*)&data2;
    return sizeof(data2);
  }
  if (rq->bRequest == RQ_GET_SWITCH)
  {
    switch_state = digitalRead(PIN_PB4);
      
    usbMsgPtr = &switch_state;

    return 1;
  }
return 0;
}

void setup(){
  pinMode(PIN_PB4, INPUT);
  pinMode(PIN_PB2, OUTPUT);
  Serial.begin(9600);
  Wire.begin();
  
  
  Wire.beginTransmission(addr); //start talking
  Wire.write(0x02); // Set the Register
  Wire.write(0x00); // Tell the HMC5883 to Continuously Measure
  Wire.endTransmission();
    usbInit();

    /* enforce re-enumeration of USB devices */
    usbDeviceDisconnect();
    delay(300);
    usbDeviceConnect();
}


void loop(){
  
  usbPoll();
  buttonState = digitalRead(PIN_PB4);
  if (buttonState == HIGH) {
    digitalWrite(PIN_PB2, HIGH);
  } else {
    digitalWrite(PIN_PB2, LOW);
  }
  //Tell the HMC what regist to begin writing data into
  Wire.beginTransmission(addr);
  Wire.write(0x03); //start with register 3.
  Wire.endTransmission();
  
 
 //Read the data.. 2 bytes for each axis.. 6 total bytes
  Wire.requestFrom(addr, 6);
  if(6<=Wire.available()){
    data2.x = Wire.read()<<8; //MSB  x 
    data2.x |= Wire.read(); //LSB  x
    data2.z = Wire.read()<<8; //MSB  z
    data2.z |= Wire.read(); //LSB z
    data2.y = Wire.read()<<8; //MSB y
    data2.y |= Wire.read(); //LSB y
  }
}

