package com.mygdx.game;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.Random;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.ScreenAdapter;
import com.badlogic.gdx.audio.Sound;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;



public class GameScreen extends ScreenAdapter{
	
	MyGdxGame myGdxGame;
	Texture enemy;
	Texture background;
	Texture background2;
	Texture gunshot;
	Texture gun;
	Texture crosshair;
	Texture bush;
	Texture again;
	Texture exit;
	Texture time_bonus;
	int[] enemyR = new int[6];
	int[] enemyX = new int[6];
	int[] enemyY = new int[6];
	long time_start = System.currentTimeMillis();
	Random rand = new Random();
	int choose;
	int onlyonce=1;
	int x,y;
	short dataX,dataY=0,dataZ=0;
	int score;
	int shot;
	int mouseX;
	int dif1,dif2,dif3;
	int difX;
	int st1,st2,st3;
	int time=60;
	int change=0;
	int onlyoncetime=1;
	int timebonus=0;
	int Xtime=-50,Ytime=568;
	byte[] ret;
	boolean check;
	BitmapFont font = new BitmapFont();
	Sound start_sound;
    private McuWithPeriBoard controller;
	
	public GameScreen (MyGdxGame myGdxGame, McuWithPeriBoard controller) {
		this.myGdxGame = myGdxGame;
		this.controller = controller;
		background = new Texture("Forest.png");
		enemy = new Texture("Soldier.png");
		gun = new Texture("gunmc.png");
		gunshot = new Texture("gunmcbang.png");
		crosshair = new Texture("crosshair.png");
		bush = new Texture("bush.png");
		background2 = new Texture("Grayforest.jpg");
		exit = new Texture("exit.jpg");
		again = new Texture("playagain.jpg");
		time_bonus = new Texture("time.png");
		start_sound = Gdx.audio.newSound(Gdx.files.internal("sound.mp3"));
		start_sound.play();
		
		
		
		for(int i=0;i<6;i++){
			enemyX[i]=rand.nextInt(924);
			enemyY[i]=200;
		}
	
		
		
	}
	
	public void update(float delta){
		if((System.currentTimeMillis()-time_start)%1000>=985){
			System.out.println(System.currentTimeMillis()-time_start);
			time--;
		}
		
		try{
			byte[] data = controller.getData();
			//System.out.println(data.length);
			dataX = ByteBuffer.wrap(data,0,2).order(ByteOrder.LITTLE_ENDIAN).getShort();
			dataY = ByteBuffer.wrap(data,2,2).order(ByteOrder.LITTLE_ENDIAN).getShort();
			dataZ = ByteBuffer.wrap(data,4,2).order(ByteOrder.LITTLE_ENDIAN).getShort();
			if(onlyonce==1){
				st1=dataX;
				st2=dataY;
				st3=dataZ;
				onlyonce=0;
			}
			dif1=dataX-st1;
			dif2=dataZ-st3;
			dif3=dataY-st2;
			difX=(int) Math.sqrt((dif3*dif3)+(dif1*dif1));
			if(dif1<0){
				dif1=dif1*2;
			}
			dif1=dif1*-1;
			
			/*if(dataX<0){
				dataX=(short) (dataX*-1);
			}
			if(dataY<0){
				dataY=(short) (dataY*-1);
			}*/
			System.out.println("X = "+dataX+" Y = "+dataY+" Z = "+dataZ);
			check = controller.getSwitch();
			//System.out.println(check);
		}
		catch(Exception e){}
		
		if(time==30 && onlyoncetime==1){
			timebonus=1;
			onlyoncetime=0;
		}
		if(timebonus==1){
			Xtime=Xtime+3;
		}
		if(time>0){
			game();
		}
		else{
			change=1; 
			end();
		}
	}
	
	public void game(){
		
		
		if((System.currentTimeMillis()-time_start)%500>400 && (System.currentTimeMillis()-time_start)%500<500){
			choose = rand.nextInt(5)+1;
			if(enemyR[choose]==0){
				enemyR[choose]=1;
			}
			if((System.currentTimeMillis()-time_start)%2000>1900 && (System.currentTimeMillis()-time_start)%2000<2000){
				choose = rand.nextInt(5)+1;
				if(enemyR[choose]==1){
					enemyR[choose]=0;
				}
			}
		}
		if(check==false){
			if(shot==0){
				shot=1;
				x=512+(dif1*2)+25;
				y=384-(dif2*2)+25;
				System.out.println(x + " " + y);
				for(int i=0;i<6;i++){
					if(enemyR[i]!=0){
						if(x>=enemyX[i]+10 && x<=(enemyX[i]+100)){
							if(y>=338 && y<=408){
								enemyR[i]=0;
								enemyX[i]=rand.nextInt(900);
								score++;
							}
						}
					}
					if(timebonus==1){
						if(x>=Xtime && x<=(Xtime+50)){
							if(y>=568 && y<=618){
								timebonus=0;
								time=time+30;
							}
						}
					}
				}
			}
		}
		else if(check==true){
			shot=0;
		}
	}
	
	public void end(){
		if(check==false){
			if(shot==0){
				shot=1;
				x=512+(difX*2)+25;
				y=384-(dif2*2)+25;
				//System.out.println(x + " " + y);
				for(int i=0;i<6;i++){
					if(enemyR[i]!=0){
						if(x>=200 && x<=400){
							if(y>=334 && y<=434){
								for(int j=0;j<6;j++){
									enemyX[j]=rand.nextInt(924);
									enemyY[j]=200;
								}
								score=0;
								time=60;
								change=0;
								onlyoncetime=1;
							}
						}
						if(x>=624 && x<=824){
							if(y>=334 && y<=434){
								Gdx.app.exit();
							}
						}
					}
				}
			}
		}
		else if(check==true){
			shot=0;
		}
	}
	
	public void drawgame(){
		SpriteBatch batch = myGdxGame.batch;
		batch.begin();
		batch.draw(background,0,0);
		if(timebonus==1){
			batch.draw(time_bonus,Xtime, 568);	
		}
		for(int i=0;i<6;i++){
			if(enemyR[i]!=0){
				batch.draw(enemy,enemyX[i],enemyY[i]);
			}
		}
		batch.draw(bush, -20,0);
		if(shot==1){
			batch.draw(gunshot,512+(dif1*2)+17,-75);
		}
		else{
			batch.draw(gun,512+(dif1*2),-75);
		}
		batch.draw(crosshair,512+(dif1*2), 384-(dif2*2));	
		font.draw(batch, "Score: "+score, 10, 25);
		font.draw(batch, "Time: "+time, 10, 740);
		
		batch.end();
	}
	
	public void drawend(){
		SpriteBatch batch = myGdxGame.batch;
		batch.begin();
		batch.draw(background2,0,0);
		batch.draw(again,200,334);
		batch.draw(exit,624,334);
		batch.draw(crosshair,512+(difX*2), 384-(dif2*2+(dif2/2)));	
		font.draw(batch, "Score: "+score, 477, 384);
		batch.end();
	}
	
	
	
	
	public void render(float delta){
		update(delta);
		
		Gdx.gl.glClearColor(0, 0, 0, 1);
		Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
		if(change==0){
			drawgame();
		}
		else{
			drawend();
		}
	}
}
